#include <stdio.h>
#include <rpc/rpc.h>
#include "cfxdr.h"

extern XDR_element xdrfile[MAX_N_XDR_FILES];

	void
#ifdef cray
	CXDRIMAT( int *ixdrid, int *nels, int *i )

#elif defined( hpux )
	cxdrimat( ixdrid, nels, i )
	int    *ixdrid;
	int	*nels;
	int	*i;

#else
	cxdrimat_( int *ixdrid, int *nels, int *i )
#endif
{
	XDR 	*xdrs;
	u_int	actual_nels, ne;

	xdrs = xdrfile[*ixdrid].xdrs;

	if( xdrs->x_op == XDR_ENCODE ) {
		if( *nels < 0 ) {
			fprintf( stderr, "FXDR library error in call to ");
			fprintf( stderr, "write real array to file %s:\n",
						xdrfile[*ixdrid].filename );
			fprintf( stderr, "negative number of elements specified!\n" );
			exit( -1 );
			}
		ne = *nels;
		xdr_array( xdrs, (char **)&i, &ne, *nels, sizeof(int), xdr_int );
		}
	else
		{
		xdr_array( xdrs, (char **)&i, &actual_nels, *nels, sizeof(int), xdr_int );
		if( actual_nels != *nels ) {
			fprintf( stderr, "FXDR library error!  Asked for " );
			fprintf( stderr, "%d integer elements, but actually read %d!\n",
					*nels, actual_nels );
			fprintf( stderr, "Error occured while reading file %s\n", 
				xdrfile[*ixdrid].filename );
			exit( -1 );
			}
		} 
}
